    NAME Roms

; This is Os.RomStubs.Asm.  This file stubs
; the routines that deal with the low level
; roms

SYSDEP_CGROUP GROUP SYSDEP_CODE

PUBLIC xCpGetMySlot, xCpSetActiveSlot, xCpGetSlotAddress

EXTRN CpGetMySlot: FAR, CpSetActiveSlot: FAR, CpGetSlotAddress: FAR


SYSDEP_CODE SEGMENT PUBLIC 'CODE'
  ASSUME CS:SYSDEP_CGROUP

; CpGetMySlot : PROCEDURE (romID) BYTE CLEAN
;     DCL romID WORD
;
; This will return the slot # of the rom which
; has the given ID.  If the romID is not found, then
; nullByte will be returned

xCpGetMySlot PROC FAR
  JMP CpGetMySlot
xCpGetMySlot ENDP


; CpSetActiveSlot : PROCEDURE (slot) BYTE CLEAN;
;     DCL slot BYTE;
;
; This will make the rom is slot be the "active" rom.
; It assumes that slot is either valid, or nullByte.  The
; current active slot will be returned.

xCpSetActiveSlot PROC FAR
  JMP CpSetActiveSlot
xCpSetActiveSlot ENDP


; CpGetSlotAddress : PROCEDURE (slot) PTR CLEAN
;     DCL slot BYTE;
;
; This will return the actual address of a given slot
; by looking at the table that was set up init time
; If slot is nullByte, then curSlot will be used

xCpGetSlotAddress PROC FAR
  JMP CpGetSlotAddress
xCpGetSlotAddress ENDP


SYSDEP_CODE ENDS

    END
